<template>
  <div class="beneficiary-history-details-accordion__title">
    <div class="meta">
      <h2 class="date">
        {{ formatDate(date) }}
      </h2>
      <div class="agent-name">{{ agentName(history.user_created) }}</div>
      <div
        class="additional-meta"
        :class="{
          'fr-icon-success-fill': history.full_file || history.first_follow_up
        }"
      >
        <template v-if="history.full_file">Dossier complet</template>
        <template v-else-if="history.first_follow_up">
          1<sup>er</sup> entretien
        </template>
      </div>
      <ul class="fr-badges-group status-badges">
        <li>
          <p
            class="fr-badge"
            :class="[statusClass]"
          >
            {{ statusOptions.get(history.status) }}
          </p>
        </li>
        <li v-if="redirectedLabel">
          <p class="fr-badge fr-badge--purple-glycine">
            {{ redirectedLabel }}
          </p>
        </li>
        <li v-if="hasUnreadNotifications">
          <p class="fr-badge fr-badge--new fr-badge--no-icon">
            <span class="fr-icon-notification-3-fill fr-icon--sm"></span>
          </p>
        </li>
      </ul>
    </div>
    <hr class="divider" />
    <ul class="fr-badges-group follow-up-types-badges">
      <li
        v-for="followUpType in followUpTypes"
        :key="followUpType.id"
      >
        <p class="fr-badge">{{ followUpType.name }}</p>
      </li>
    </ul>
    <button
      class="fr-btn collapse-btn fr-btn--tertiary"
      aria-expanded="false"
      :aria-controls="accordionId"
      :title="collapseBtnLabel"
      @click="$emit('toggleExpand')"
    >
      <span :class="[collapseBtnIcon]"></span>
      <span>{{ collapseBtnLabel }}</span>
    </button>
  </div>
</template>

<script setup>
  import { formatDate, agentName } from '~~/utils'
  import {
    HELP_REQUEST_STATUS_OPTIONS,
    STATUS_CLASSES as HELP_REQUEST_STATUS_CLASSES
  } from '~~/utils/constants/help-requests'
  import {
    INTERVIEW_STATUS_OPTIONS,
    STATUS_CLASSES as INTERVIEW_STATUS_CLASSES
  } from '~~/utils/constants/interview'

  const props = defineProps({
    history: { type: Object, required: true },
    accordionId: { type: String, required: true },
    expanded: { type: Boolean, default: false },
    hasUnreadNotifications: { type: Boolean, default: false }
  })

  defineEmits(['toggleExpand'])

  const date = computed(() =>
    props.history.isInterview ? props.history.date : props.history.opening_date
  )

  const statusOptions = computed(() =>
    props.history.isInterview
      ? INTERVIEW_STATUS_OPTIONS
      : HELP_REQUEST_STATUS_OPTIONS
  )

  const statusClass = computed(() => {
    if (props.history.isInterview) {
      return INTERVIEW_STATUS_CLASSES[props.history.status] || ''
    }
    return HELP_REQUEST_STATUS_CLASSES[props.history.status] || ''
  })

  const redirectedLabel = computed(() => {
    if (props.history.isInterview) {
      if (props.history.redirected) {
        const label = 'Réorienté'
        return props.history.organisation_name
          ? `${label} : ${props.history.organisation_name}`
          : label
      }
    }
    return ''
  })

  const followUpTypes = computed(() => {
    if (props.history.isInterview) {
      return props.history.follow_up_types.map(f => f.follow_up_types_id)
    }
    return [props.history.follow_up_type]
  })

  const historyTypeLabel = computed(() =>
    props.history.isInterview
      ? "la synthèse d'entretien"
      : "l'instruction de demande d'aide"
  )

  const collapseBtnLabel = computed(
    () => `Voir les détails de ${historyTypeLabel.value}`
  )

  const collapseBtnIcon = computed(() =>
    props.expanded ? 'fr-icon-subtract-line' : 'fr-icon-add-line'
  )
</script>

<style lang="scss" scoped>
  @use '@gouvfr/dsfr/src/core/index' as dsfr;

  .beneficiary-history-details-accordion__title {
    position: relative;
    display: grid;
    padding: 1rem;
    column-gap: 0.5rem;
    border-radius: 0.5rem 0.5rem 0 0;
    grid-template-areas:
      'meta accordion-btn'
      'divider accordion-btn'
      'follow-up-types-badges accordion-btn';
    color: #fff;
    grid-template-columns: auto max-content;
  }

  .meta {
    grid-area: meta;
    display: grid;
    column-gap: 1rem;
    grid-template-areas: 'agent-name date additional-meta status-badges';
    grid-template-columns: max-content max-content max-content auto;
    align-items: center;
  }

  .date {
    @include dsfr.text-style(md);

    --title-spacing: 0;

    grid-area: date;
    color: #fff;
  }

  .agent-name {
    grid-area: agent-name;
    font-weight: 700;

    /**
     * The resulted design is quite ugly but it seems browsers leaves the
     * container to the max width once text is wrapped instead of shrinking it
     * to the last text character.
     * See https://stackoverflow.com/a/12377883/7916042
     */
    max-width: 10rem;
  }

  .additional-meta {
    grid-area: additional-meta;

    &::before {
      margin-right: 0.25rem;
    }
  }

  .status-badges {
    grid-area: status-badges;
    justify-self: end;
    justify-content: end;
  }

  .divider {
    --text-spacing: 0 0 0.5rem;

    grid-area: divider;
  }

  .follow-up-types-badges {
    grid-area: follow-up-types-badges;
    margin-bottom: -0.5rem;
  }

  .collapse-btn {
    color: #fff;
    grid-area: accordion-btn;
    box-shadow: none;
    align-self: center;
    outline-width: 0;

    span:nth-child(2) {
      display: none;
    }

    &:hover,
    &:active {
      color: var(--text-default-grey);
    }

    &::before {
      content: '';
      display: block;
      position: absolute;
      inset: 0;
      width: 100%;
      height: 100%;
      outline-offset: 2px;
      outline-style: inherit;
      outline-color: inherit;
      outline-width: 2px;
      border-radius: 0.5rem 0.5rem 0 0;
    }
  }
</style>
